
'use strict'  //Ens permet emprar les derreres característiques de Javascript 
const express = require('express'); // carreguem el mòdul express
var bodyParser = require('body-parser');//convertim les peticions POST a objectes Javascript
var app = express();// creem una variable app on carreguem el framework express
var server = require('http').Server(app);
var io = require('socket.io')(server);
//import { getUsername } from './controllers/user.js';
//let val = getUsername();

//conexixo amb socket io
var messages = [{
  id: 1,
  text: " Chat en funcionament",
  author: "<b>Socket.io</b>"
}];


app.use(express.static('public'));


//configuració del servidor de socket io


io.on('connection', function(socket) {
  console.log('Un usuari ha entrat al chat');
  socket.emit('messages', messages);
  socket.on('disconnect', function(){
    console.log('Un usuari ha sortit');
  });



  socket.on('new-message', function(data) {
    messages.push(data);
    io.sockets.emit('messages', messages);
  });
});

server.listen(8081, function() {
  console.log("Servidor socket funcionant al port 8081");
});






//carreguem les rutes http
var user_routes = require('./routes/user');
var follow_routes = require('./routes/follow');
var publication_routes = require('./routes/publication');
var message_routes = require('./routes/message');


// configuració de middelwares
//Aquest métode ens dona error de deprecated    
app.use(bodyParser.urlencoded({extend:false})); // configurem body-parser
// https://stackoverflow.com/questions/30497245/expressjs-error-body-parser-deprecated
app.use(bodyParser.json()); //convertim les peticions POST a objectes json


//configurem capçaleres cors

app.use((req, res, next) => {

    res.header('Access-Control-Allow-Origin', '*');
    res.header('Access-Control-Allow-Headers', 'Authorization, X-API-KEY, Origin, X-Requested-With, Content-Type, Accept');
    res.header('Access-Control-Allow-Methods', 'GET, POST, OPTIONS, PUT, DELETE');
    res.header('Allow', 'GET, POST, OPTIONS, PUT, DELETE');
 
    next();
});



// gestionem les rutes http per mitjà de middelwares
app.use('/api',user_routes);
app.use('/api',follow_routes);
app.use('/api', publication_routes); 
app.use('/api', message_routes); 
app.use(express.static('public'));

module.exports = app;// Exportem la configuració de app