'use strict' // requerim strict per a poder emprar les derreres funcionalitats de ecma script

var express = require('express'); // carreguem express
var PublicationController = require('../controllers/publication'); // carreguem el controlador de seguiment 
var api = express.Router(); // carreguem el router d'express
var md_auth = require('../middlewares/auth');  // carreguem el middlware d'autenticació
var multipart = require('connect-multiparty');// middleware de pujada d'arxius
var md_upload = multipart({uploadDir: './uploads/publications'});//middleware de pe pujada d'arxius


api.post('/publication',md_auth.ensureAuth,PublicationController.savePublication);
api.get('/publications/:page?',md_auth.ensureAuth,PublicationController.getPublications);
api.get('/publications-user/:user/:page?',md_auth.ensureAuth,PublicationController.getPublicationsUser);
api.get('/publication/:id',md_auth.ensureAuth,PublicationController.getPublication);
api.delete('/publication/:id',md_auth.ensureAuth,PublicationController.deletePublication);
api.post('/upload-image-pub/:id',[md_auth.ensureAuth,md_upload],PublicationController.uploadImage);
api.get('/get-image-pub/:imageFile',PublicationController.getImageFile);




module.exports = api;