'use strict' //Ens permet emprar les derreres característiques de Javascript 

var express = require('express'); // carreguem express
var UserController = require('../controllers/user'); // carreguem el controlador d'usuari 
var api = express.Router(); // carreguem el router d'express
var md_auth = require('../middlewares/auth'); //requerim el middleware d'autenticació
var multipart = require('connect-multiparty'); // carreguem la llibrería multiparty
var md_upload = multipart({uploadDir:'./uploads/users/'}); // creem middleware de pujades
api.get('/home', UserController.home);// definim la ruta
api.get('/prova',md_auth.ensureAuth, UserController.prova); // definim la ruta
api.post('/register',UserController.saveUser);
api.post('/login',UserController.loginUser);
api.get('/user/:id',md_auth.ensureAuth,UserController.getUser);
api.get('/username/',md_auth.ensureAuth,UserController.getUsername);
api.get('/users/:page?',md_auth.ensureAuth,UserController.getUsers);
api.put('/update-user/:id',md_auth.ensureAuth,UserController.updateUser);
api.post('/upload-image-user/:id',[md_auth.ensureAuth, md_upload],UserController.uploadImage);
api.get('/get-image-user/:imageFile',md_auth.ensureAuth,UserController.getImageFile);
api.get('/counters/:id?',md_auth.ensureAuth,UserController.getCounters);


module.exports = api; // exportam la configuració 