import { Component, OnInit, DoCheck } from '@angular/core';
import { DomSanitizer } from "@angular/platform-browser";
import { UserService } from './services/user.service';
import { Router, ActivatedRoute, Params} from '@angular/router';
import { Global } from './services/global';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  providers: [ UserService]
})
export class AppComponent implements OnInit, DoCheck {
  public title:string;
  public identity;
  public url: string;

  constructor(
    private _userService:UserService,
    private _route: ActivatedRoute,
    private _router: Router

  ){
    this.title = 'SocialCMR';
    this.url = Global.url;
  }
  ngOnInit(){
      this.identity = this._userService.getIdentity();

  }

  ngDoCheck(){ // cada cop que hi ha un canvi a la app, refresca les dades
    this.identity = this._userService.getIdentity();
  }

  logout(){
    localStorage.clear();
    this.identity = null;
    this._router.navigate(['/login']);

  }


}
