import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { routing, appRoutingProviders } from './app.routing';
import { FormsModule } from '@angular/forms';
import { HttpClientModule } from '@angular/common/http';
import { MomentModule } from 'angular2-moment';
//modul de missatges
import { MessagesModule} from './messages/messages.module';

//carrega de components
import { AppRoutingModule } from './app-routing.module';
import { AppComponent} from './app.component';
import { SafePipe } from './components/chat/chat.component';
import { LoginComponent } from './components/login/login.component';
import { RegisterComponent } from './components/register/register.component';
import { HomeComponent } from './components/home/home.component';
import { UserEditComponent } from './components/user-edit/user-edit.component';
import { UsersComponent } from './components/users/users.component';
import { SidebarComponent } from './components/sidebar/sidebar.component';
import { TimelineComponent } from './components/timeline/timeline.component';
import { PublicationsComponent } from './components/publications/publications.component';
import { ProfileComponent } from './components/profile/profile.component';
import { ChatComponent } from './components/chat/chat.component';
import {UserService} from './services/user.service';
import {UserGuard} from './services/user.guard';
import { RichTextEditorAllModule } from '@syncfusion/ej2-angular-richtexteditor';



@NgModule({
  declarations: [
    AppComponent,
    LoginComponent,
    RegisterComponent,
    HomeComponent,
    UserEditComponent,
    UsersComponent,
    SidebarComponent,
    TimelineComponent,
    PublicationsComponent,
    ProfileComponent,
    SafePipe,
    ChatComponent



  ],
  imports: [
    BrowserModule,
    FormsModule,
    routing,
    HttpClientModule,
    MomentModule,
    MessagesModule,
    RichTextEditorAllModule
  ],
  providers: [
  appRoutingProviders,
  UserService,
  UserGuard
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }
