import { ModuleWithProviders } from '@angular/core';
import { Routes,RouterModule } from '@angular/router';

//importació de nou components
//importació de login
import { LoginComponent } from './components/login/login.component';
//importació del modul de registre
import { RegisterComponent } from './components/register/register.component';
import {HomeComponent} from './components/home/home.component';
import { UserEditComponent } from './components/user-edit/user-edit.component';
import { UsersComponent } from './components/users/users.component';
import { TimelineComponent } from './components/timeline/timeline.component';
import { ProfileComponent } from './components/profile/profile.component';
import { ChatComponent } from './components/chat/chat.component';
import {UserGuard} from './services/user.guard';



const appRoutes: Routes = [
  //indicam el path de l'objecte
  { path: '', component:HomeComponent, canActivate:[UserGuard]},
  { path: 'login', component: LoginComponent},
  { path: 'register', component: RegisterComponent},
  { path: 'home', component: HomeComponent, canActivate:[UserGuard]},
  { path: 'data-user', component: UserEditComponent, canActivate:[UserGuard]},
  { path: 'people/:page', component: UsersComponent, canActivate:[UserGuard]},
  { path: 'people', component: UsersComponent, canActivate:[UserGuard]},
  { path: 'timeline', component: TimelineComponent, canActivate:[UserGuard]},
  { path: 'profile/:id', component: ProfileComponent, canActivate:[UserGuard]},
  { path: 'chat', component: ChatComponent, canActivate:[UserGuard]},
  { path: '**', component: HomeComponent, canActivate:[UserGuard]}

];

//exportem la configuració de rutes

export const appRoutingProviders: any[] = [];
export const routing: ModuleWithProviders = RouterModule.forRoot(appRoutes);
