import {Component,ViewEncapsulation, ViewChild, ElementRef, PipeTransform, Pipe } from '@angular/core';
import { DomSanitizer } from "@angular/platform-browser";
import {Router, ActivatedRoute, Params} from '@angular/router';
import {UserService} from '../../services/user.service';
import {Global} from '../../services/global';


@Pipe({ name: 'safe' })
export class SafePipe implements PipeTransform {
  constructor(private sanitizer: DomSanitizer) { }
  transform(url) {
    return this.sanitizer.bypassSecurityTrustResourceUrl(url);
  }
}


@Component({
    selector: 'chat',
    templateUrl: './chat.component.html',
    providers: [UserService]
})

export class ChatComponent {

      public title: string;  // cream la variable per al títol
      public chat: string = "http://80.24.106.191:8081/";



}
