import {Component, OnInit } from '@angular/core';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {Publication} from '../../models/publication';
import {UserService} from '../../services/user.service';
import {PublicationService} from '../../services/publication.service';
import {Global} from '../../services/global';
import {Message} from '../../models/message';
import {MessageService} from '../../services/message.service';


@Component({
    selector: 'home',
    templateUrl: './home.component.html',
    providers: [UserService, PublicationService,MessageService]
})

export class HomeComponent implements OnInit{

    public title: string;  // cream la variable per al títol
      public message:Message;
      public messages: Message [];
      public pages;
      public page;
      public total;
      public next_page;
      public prev_page;
      public user;
      public identity;
      public token;
      public status: string;
      public url:string;
      public itemsPerPage;
        public publications : Publication  [];



    constructor(
          private _route:ActivatedRoute,
          private _router:Router,
          private _userService: UserService,
          private _publicationService: PublicationService,
          private _messageService:MessageService
      ){

      this.title = 'Benvinguts a SocialCMR';
      this.user = this._userService.getIdentity();
      this.identity = this.user;
      this.token = this._userService.gettoken();
      this.url = Global.url;
      this.page = 1;
    }
          ngOnInit(){
          //console.log('Timeline funcionant');
          this.getPublications(this.page);
          this.actualPage();
        }
        getPublications(page, adding = false){
          this._publicationService.getPublications(this.token, page).subscribe(
          response => {


                        if(!response.publications){
                                 this.status = 'error';
                        }else{

                        this.status = 'success';
                        this.total = response.total_items;
                        this.pages = response.pages;
                        this.itemsPerPage = response.items_per_page;


                        if(!adding){  // afegim noves publicacions a l'array amb un botó infinit
                            this.publications = response.publications;

                        }else{
                            var a = this.publications;
                            var b = response.publications;
                            this.publications = a.concat(b);
                            //feim scroll automatic amb jquery
                            $("html,body").animate({scrollTop:$('html').prop("scrollHeight")},600);
                        }

                        if(page > this.pages){
                                this._router.navigate(['/home']);
                        }
                        }
                  },
                  error =>{
                    var errorMessage = <any>error;
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
        }
         getMessages(token, page){
        this._messageService.getMyMessages(token, page).subscribe(
          response => {
                        if(!response){

                                 this.status = 'error';
                        }else{
                                this.status = 'success';
                                this.messages = response.messages;
                                this.total = response.total;
                                this.pages = response.pages;
                                if(page > this.pages){
                                  this._router.navigate(['/missatges',1]);
                                }
                        }



                  },
                  error =>{
                    var errorMessage = <any>error;
                    this._router.navigate(['/profile',this.identity._id]);
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
      }
       //recollim la pagina actual
        actualPage(){
          this._route.params.subscribe(params =>{
            let page = +params['page'];
            this.page = page;
            if(!page){
              page = 1;
            }else{
              this.next_page = page + 1;
              this.prev_page = page - 1;

              if(this.prev_page <= 0){
                this.prev_page = 1;
              }

            }
            //retornem el llistat d'usuaris
            this.getMessages(this.token, page);

          });

        }




}
