import {Component, OnInit} from '@angular/core';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {HttpClientModule} from '@angular/common/http';
import {FormsModule} from '@angular/forms';
import {User} from '../../models/user';

//importam el servei
import { UserService } from '../../services/user.service';

@Component({   //cream un nou component
  selector: 'login',
  templateUrl: './login.component.html',
  providers: [
  UserService
  ]
})

export class LoginComponent implements OnInit{
  public title:string;
  public user:User;
  public status:string;
  public identity;
  public token;

 constructor(
      private _route: ActivatedRoute ,
      private _router: Router,
      private _userService: UserService

    ){
    this.title = 'Identificació';
    this.user = new User( "","","","","","","Role_user","");
  }
  ngOnInit(){
    console.log('Complement de Login funcionant');
  }


  onSubmit(form){

    //login d'usuari
    this._userService.signup(this.user).subscribe(

          response => {
              this.identity = response.user;

              if(!this.identity || !this.identity._id){
                this.status = 'error';
              }else{

                 // feim la persistencia de les dades de sessió
                  localStorage.setItem('identity',JSON.stringify(this.identity));
                 //obtenim el token d'usuari
                 this.getToken(form);
              }
          },
          error => {
              console.log(errorMessage);
              var errorMessage = <any>error;
              if(errorMessage != null){
                this.status = 'error';
                form.reset();
              }

          }

      );

  }



  getToken(form){

    //login d'usuari
    this._userService.signup(this.user, 'true').subscribe(

          response => {
              this.token = response.token;

              if(this.token.length <= 0 ){
                this.status = 'error';
              }else{

                 // feim la persistencia del token
                 localStorage.setItem('token',this.token);
                 //obtenim els contadors
                 this.getCounters();

              }
          },
          error => {
              console.log(errorMessage);
              var errorMessage = <any>error;
              if(errorMessage != null){
                this.status = 'error';
                form.reset();
              }

          }

      );

  }

  getCounters(){
          this._userService.getCounters().subscribe(
              response => {
                  console.log(response);
                  localStorage.setItem('stats', JSON.stringify(response));
                  this.status = 'success';
                  this._router.navigate(['/']);

              },
              error =>{
                console.log(<any>error);
              }

            )
  }

}
