import {Component, OnInit} from '@angular/core';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {FormsModule} from '@angular/forms';
import {User} from '../../models/user';
import {Follow} from '../../models/follow';
import {Global} from '../../services/global'

//importam el servei
import { UserService } from '../../services/user.service';
import { FollowService } from '../../services/follow.service';

@Component({   //cream un nou component
  selector: 'profile',
  templateUrl: './profile.component.html',
  providers: [
  UserService, FollowService
  ]
})

  export class ProfileComponent implements OnInit{
    public title:string;
    public user: User;
    public status: string;
    public identity;
    public token;
    public stats;
    public url;
    public followed;
    public follows;
    public following;
    public amistat;

    constructor(
        private _route:ActivatedRoute,
        private _router:Router,
        private _userService:UserService,
        private _followService: FollowService



      ){

      this.title = 'Perfil';
      this.identity = this._userService.getIdentity();
      this.token = this._userService.gettoken();
      this.url = Global.url;
      this.following = false;
      this.followed=false;
      this.amistat = true;
      this.stats = this._userService.getStats();


      }

      ngOnInit(){
          //console.log('Perfil carregat correctament')
          this.loadPage();

       }

       loadPage(){
        this._route.params.subscribe(params =>{
          let id = params['id'];
          this.getUser(id);
          this.getCounters(id);
        })
       }

      getUser(id){
        this._userService.getUser(id).subscribe(
          response => {


                        if(response.user){

                                 this.user = response.user;


                                 if(response.following && response.following._id){
                                  this.following = true;
                                 }else{this.following=false}
                                 if(response.followed && response.followed._id){
                                  console.log('te segueix')
                                  this.followed = true;
                                 }else{this.followed=false}


                        }else{
                            this.status = 'error';


                        }


                  },
                  error =>{

                    var errorMessage = <any>error;
                    this._router.navigate(['/profile',this.identity._id]);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
        }

        getCounters(id){
        this._userService.getCounters(id).subscribe(
          response => {


                        if(!response){

                                 this.status = 'error';
                        }else{
                                //console.log(response)

                                 this.stats = response;
                        }

                  },
                  error =>{
                    var errorMessage = <any>error;
                    this._router.navigate(['/profile',this.identity._id]);
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
        }



                  public followUserOver;
                  mouseEnter(user_id){
                    this.followUserOver = user_id;

                  }
                  mouseLeave(user_id){
                    this.followUserOver = 0;
                  }

                  followUser(followed){
                      var follow = new Follow('',this.identity._id, followed);
                      this._followService.addFollow(this.token, follow).subscribe(

                          response => {
                                if(!response.follow){
                                  this.status = 'error';
                                }else{
                                  this.status = 'succes';
                                  this.follows.push(followed);
                                  location.reload();

                                }

                          },


                              error =>{
                            var errorMessage = <any>error;
                            console.log(errorMessage);
                                if(errorMessage != null){
                                  this.status = 'error';
                                }
                          }


                        )
                  }





          unfollowUser(followed){
                  this._followService.deleteFollow(this.token, followed).subscribe(

                  response => {

                      var search = this.follows.indexOf(followed);
                        if(search != -1){
                          this.follows.splice(search, 1);
                        }else{
                          this.status = 'succes';
                          this.follows.push(followed);
                        }

                  },
                   error =>{
                      var errorMessage = <any>error;
                      console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }


                )

          }


  }





