import {Component, OnInit,Input} from '@angular/core';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {Publication} from '../../models/publication';
import {UserService} from '../../services/user.service';
import {UploadService} from '../../services/upload.service';
import {PublicationService} from '../../services/publication.service';
import {Global} from '../../services/global';


@Component({
    selector: 'publications',
    templateUrl: './publications.component.html',
    providers: [UserService, UploadService, PublicationService]


})

export class PublicationsComponent implements OnInit{
        public title:string;
        //public user;
        public identity;
        public follows;
        public token;
        public status: string;
        private _uploadService: UploadService;
        public url:string;
        public page;
        public total;
        public pages;
        public itemsPerPage;
        public showImage;
        public publications : Publication  [];

        @Input() user:string;




        constructor(

              private _route: ActivatedRoute,
              private _router: Router,
              private _userService: UserService,
              private _publicationService: PublicationService

          ){
          this.title = 'Publications';
          this.user = this._userService.getIdentity();
          this.identity = this.user;
          this.token = this._userService.gettoken();
          this.url = Global.url;
          this.page = 1;
        }

        ngOnInit(){
          //console.log('Publicacions funcionant');
          this.getPublications(this.user,this.page);


        }


         getPublications(user , page, adding = false){
          this._publicationService.getPublicationsUser(this.token,user, page).subscribe(
          response => {


                        if(!response.publications){
                                 this.status = 'error';
                        }else{

                        this.status = 'success';
                        this.total = response.total_items;
                        this.pages = response.pages;
                        this.itemsPerPage = response.items_per_page;


                        if(!adding){  // afegim noves publicacions a l'array amb un botó infinit
                            this.publications = response.publications;

                        }else{
                            var a = this.publications;
                            var b = response.publications;
                            this.publications = a.concat(b);
                            //feim scroll automatic amb jquery
                            $("html,body").animate({scrollTop:$('html').prop("scrollHeight")},600);
                        }

                        if(page > this.pages){
                                this._router.navigate(['/home']);
                        }
                        }
                  },
                  error =>{
                    var errorMessage = <any>error;
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
        }

        // si ja no hi ha mes publicacions no mostram el boto
        public no_more = false;
        public redirect = false;
        viewMore(){



            this.page+=1;
            if(this.page == this.pages){
              this.no_more = true;
            }

            this.getPublications(this.user,this.page, true)


        }
        refresh(){
          window.location.reload();
        }


        showThisImage(id){
            this.showImage = id;
        }

        hideThisImage(id){
            this.showImage = '0';
        }
        deletePublication(id){
          this._publicationService.deletePublication(this.token, id).subscribe(
                response => {
                      this.refresh();
                  },
                  error =>{

                    var errorMessage = <any>error;
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );



        }


}
