import {Component, OnInit} from '@angular/core';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {HttpClientModule} from '@angular/common/http';
import {FormsModule} from '@angular/forms';
import {User} from '../../models/user';
//importam el servei
import { UserService } from '../../services/user.service';

@Component({   //cream un nou component
  selector: 'register',
  templateUrl: './register.component.html',
  providers: [
  UserService
  ]
})

export class RegisterComponent implements OnInit{
  public title:string;
  public user:User;
  public status:string;

  constructor(
      private _route: ActivatedRoute ,
      private _router: Router,
      private _userService: UserService

    ){
    this.title = 'Formulari de registre';
    this.user = new User( "","","","","","","Role_user","");
  }
   ngOnInit(){
    console.log('Complement de Registre funcionant');
  }
   onSubmit(form){

    this._userService.register(this.user).subscribe(
            response => {

                    if(response.user && response.user._id){
                      this.status = 'success';

                    }else{

                      this.status = 'error';
                      form.reset();

                    }

            },
            error =>{
              console.log(<any>error);
            }

       );
  }
}
