//importem tot l necessari
import {Component, OnInit, EventEmitter, Input, Output} from '@angular/core';
import {UploadService} from '../../services/upload.service';
import {User} from '../../models/user';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {UserService} from '../../services/user.service';
import {PublicationService} from '../../services/publication.service';
import {Global} from '../../services/global';
import {Publication } from '../../models/publication';



@Component({
  selector:'sidebar',
  templateUrl: './sidebar.component.html',
  providers: [UserService, PublicationService,UploadService]
})



export class SidebarComponent implements OnInit{

        public title:string;
        public identity;
        public token;
        public url:string;
        public status:string;
        public stats;
        public count;
        public publication:Publication;




    constructor(

              private _userService: UserService,
              private _publicationService: PublicationService,
              private _uploadService: UploadService,
              private _route: ActivatedRoute ,
              private _router: Router


          ){
          this.title = 'Secció de sidebar';
          this.identity = this._userService.getIdentity();
          this.token = this._userService.gettoken();
          this.stats = this._userService.getStats();
          this.url = Global.url;
          this.publication = new Publication("","","","",this.identity._id);


        }



        ngOnInit(){
          //console.log('Complement sidebar funcionant');

        }
        onSubmit(form, $event){
          this._publicationService.addPublication(this.token, this.publication).subscribe(
                  response => {
                        if(!response.publication){
                          this.status = 'error';
                        }else{
                         // this.publication = response.publication;

                         if(this.filesToUpload){
                          this._uploadService.makeFileRequest(this.url + 'upload-image-pub/'+ response.publication._id, [], this.filesToUpload, this.token, 'image')
                          .then((result:any) => {
                                    this.publication.file = result.image;
                                    this.status = 'success';
                                    form.reset();
                                    this.sended.emit({send:'true'});
                                    this._router.navigate(['/timeline']);
                          })

                         }else{


                                    this.status = 'success';
                                    form.reset();
                                    this.sended.emit({send:'true'});
                                    this._router.navigate(['/timeline']);

                         }



                        }
                  },
                  error =>{
                    var errorMessage = <any>error;
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                          this.sended.emit({send:'true'})
                        }
                  }
              );

        }

        public filesToUpload: Array<File>;
        fileChangeEvent(fileInput:any){
          this.filesToUpload = <Array<File>>fileInput.target.files;
        }



        //sortides de Ouput
        @Output() sended =  new EventEmitter();
        sendPublication(event){
          this.sended.emit({send:'true'})

        }



}
