import {Component, OnInit} from '@angular/core';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {Publication} from '../../models/publication';
import {UserService} from '../../services/user.service';
import {UploadService} from '../../services/upload.service';
import {PublicationService} from '../../services/publication.service';
import {Global} from '../../services/global';
import { HostListener } from '@angular/core';


@Component({
    selector: 'timeline',
    templateUrl: './timeline.component.html',
    providers: [UserService, UploadService, PublicationService]


})

export class TimelineComponent implements OnInit{
        public title:string;
        public user;
        public identity;
        public token;
        public status: string;
        private _uploadService: UploadService;
        public url:string;
        public page;
        public total;
        public pages;
        public itemsPerPage;
        public publications : Publication  [];
        public showImage;
        public showWrite:string;



        constructor(

              private _route: ActivatedRoute,
              private _router: Router,
              private _userService: UserService,
              private _publicationService: PublicationService

          ){
          this.title = 'Timeline';
          this.user = this._userService.getIdentity();
          this.identity = this.user;
          this.token = this._userService.gettoken();
          this.url = Global.url;
          this.page = 1;
        }

        ngOnInit(){
          //console.log('Timeline funcionant');
          this.getPublications(this.page);
        }
        getPublications(page, adding = false){
          this._publicationService.getPublications(this.token, page).subscribe(
          response => {


                        if(!response.publications){
                                 this.status = 'error';
                        }else{

                        this.status = 'success';
                        this.total = response.total_items;
                        this.pages = response.pages;
                        this.itemsPerPage = response.items_per_page;
                        this.showWrite = 'non';



                        if(!adding){  // afegim noves publicacions a l'array amb un botó infinit
                            this.publications = response.publications;

                        }else{
                            var a = this.publications;
                            var b = response.publications;
                            this.publications = a.concat(b);
                            //feim scroll automatic amb jquery
                            var scroll=$('#scroll');
                                scroll.animate({scrollTop: scroll.prop("scrollHeight")});
                        }

                        if(page > this.pages){
                                this._router.navigate(['/timeline']);
                        }
                        }
                  },
                  error =>{
                    var errorMessage = <any>error;
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
        }

        shoWrite(){
            this.showWrite = 'success';
        }

        lesWrite(){
            this.showWrite = 'non';
        }

        public showThisImage(id){
          this.showImage = id;
        }

          hideThisImage(id){
            this.showImage = '0';
        }

        // si ja no hi ha mes publicacions no mostram el boto
        public no_more = false;
          @HostListener("window:scroll", ["$event"])
                onWindowScroll() {

               if ((window.innerHeight + window.scrollY) >= document.body.offsetHeight) {
                   this.page+=1;
                   if(this.page == this.pages){
                      this.no_more = true;
                    }
                  this.getPublications(this.page, true)


                    }

                }


        refresh(event = null){
            this.getPublications(1)

        }


         deletePublication(id){
          this._publicationService.deletePublication(this.token, id).subscribe(
                response => {
                      this.refresh();
                  },
                  error =>{

                    var errorMessage = <any>error;
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );



        }


}
