import {Component, OnInit} from '@angular/core';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {User} from '../../models/user';
import {UserService} from '../../services/user.service';
import {UploadService} from '../../services/upload.service';
import {Global} from '../../services/global';


@Component({
    selector: 'user-edit',
    templateUrl: './user-edit.component.html',
    providers: [UserService, UploadService]


})

export class UserEditComponent implements OnInit{
        public title:string;
        public user: User;
        public identity;
        public token;
        public status: string;
       // private _uploadService: UploadService;
        public url:string;



        constructor(

              private _route: ActivatedRoute,
              private _router: Router,
              private _userService: UserService,
              private _uploadService: UploadService

          ){
          this.title = 'Actualitza les dades de usuari';
          this.user = this._userService.getIdentity();
          this.identity = this.user;
          this.token = this._userService.gettoken();
          this.url = Global.url;

        }


        ngOnInit(){
          console.log(this.user);
         // console.log('El complement de user-edit està funcionant correctament')
        }

        onSubmit(){

          //actualitzam l'usuari logat
          this._userService.updateUser(this.user).subscribe(

                response =>{
                  if(!response.user){
                    this.status = 'error';
                  }else{
                    this.status = 'success';
                    localStorage.setItem('identity', JSON.stringify(this.user)); //actualitzam localStorage
                    this.identity = this.user; //obtnim les dades d'usuari
                    //pujam la imàtge d'usuari
                    this._uploadService.makeFileRequest(this.url + 'upload-image-user/' + this.user._id, [], this.filesToUpload, this.token, 'image').
                                        then((result:any) => {
                                            //console.log(result.user.image);
                                            this.user.image = result.image;// actualitzam el valor de la imàtge

                                            localStorage.setItem('identity', JSON.stringify(this.user));//convertim l'objecte a un string
                                            console.log(this.user.image);
                                        });
                  }

                },
                error =>{
                  var errorMessage = <any>error;
                  console.log(errorMessage);
                  if(errorMessage != null){
                    this.status = 'error';
                  }
                }

            )
        }
        //cream variable de pujada de fitxers
        public filesToUpload: Array<File>;

        //obtenim els fitxers a pujar
        fileChangeEvent(fileInput: any){
            this.filesToUpload = <Array<File>>fileInput.target.files;
            console.log(this.filesToUpload);
        }


}
