//importem tot l necessari
import {Component, OnInit} from '@angular/core';
import {Router, ActivatedRoute, Params} from '@angular/router';
import {User} from '../../models/user';
import {Follow} from '../../models/follow';
import {UserService} from '../../services/user.service';
import {FollowService} from '../../services/follow.service';
import {Global} from '../../services/global';
import { HostListener } from '@angular/core';


@Component({
  selector:'users',
  templateUrl: './users.component.html',
  providers: [UserService, FollowService]
})

export class UsersComponent implements OnInit{

        public title:string;
       // public user: User;
        public identity;
        public token;
        public url:string;
        public page;
        public next_page;
        public prev_page;
        public status:string;
        public total;
        public users : User[];
        public pages;
        public follows;
        public itemsPerPage;




    constructor(

              private _route: ActivatedRoute,
              private _router: Router,
              private _userService: UserService,
              private _followService: FollowService

          ){
          this.title = 'Secció de gent';
          this.identity = this._userService.getIdentity();
          this.token = this._userService.gettoken();
          this.url = Global.url;
          this.page = 1;
        }

        ngOnInit(){
          //console.log('Complement UserComponent funcionant')
          this.getUsers(this.page);
        }

        getStats(){

        }




        getUsers(page,adding=false){
              this._userService.getUsers(page).subscribe(
                  response => {
                        if(!response.users){
                          this.status = 'error';
                        }else{
                          this.total = response.total;
                          //this.users = response.users;
                          this.pages = response.pages;
                          this.itemsPerPage = response.items_per_page;
                          this.follows = response.users_following;
                           if(!adding){  // afegim noves publicacions a l'array amb un botó infinit
                            this.users = response.users;

                        }else{
                            var a = this.users;
                            var b = response.users;
                            this.users = a.concat(b);
                            //feim scroll automatic amb jquery
                            var scroll=$('#scroll');
                                scroll.animate({scrollTop: scroll.prop("scrollHeight")});
                        }


                          if(page > this.pages){
                            this._router.navigate(['/people',1]);
                          }
                        }
                  },
                  error =>{
                    var errorMessage = <any>error;
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
          }

              // si ja no hi ha mes publicacions no mostram el boto
              public no_more = false;
              viewMore(){

                    this.page+=1;
                   if(this.page == this.pages){
                      this.no_more = true;
                    }
                  this.getUsers(this.page, true)

              }

                 refresh(){
                    window.location.reload()
                }


                @HostListener("window:scroll", ["$event"])
                onWindowScroll() {

               if ((window.innerHeight + window.scrollY) >= document.body.offsetHeight) {
                   this.page+=1;
                   if(this.page == this.pages){
                      this.no_more = true;
                    }
                  this.getUsers(this.page, true)

                    }

                }



          public followUserOver;
          mouseEnter(user_id){
            this.followUserOver = user_id;

          }
          mouseLeave(user_id){
            this.followUserOver = 0;
          }

          followUser(followed){
              var follow = new Follow('',this.identity._id, followed);
              this._followService.addFollow(this.token, follow).subscribe(

                  response => {
                        if(!response.follow){
                          this.status = 'error';
                        }else{
                          this.status = 'succes';
                          this.follows.push(followed);
                        }

                  },


                      error =>{
                    var errorMessage = <any>error;
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }


                )
          }




          unfollowUser(followed){
                  this._followService.deleteFollow(this.token, followed).subscribe(

                  response => {

                      var search = this.follows.indexOf(followed);
                        if(search != -1){
                          this.follows.splice(search, 1);
                        }else{
                          this.status = 'succes';
                          this.follows.push(followed);
                        }

                  },
                   error =>{
                      var errorMessage = <any>error;
                      console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }


                )

          }





}
