 import {Component, OnInit, DoCheck} from '@angular/core';
//importem tot l necessari
import {Router, ActivatedRoute, Params} from '@angular/router';
import {Follow} from '../../../models/follow';
import {Message} from '../../../models/message';
import {MessageService} from '../../../services/message.service';
import {FollowService} from '../../../services/follow.service';
import {UserService} from '../../../services/user.service';
import {Global} from '../../../services/global';

//definim el component
//adjuntam metadades
@Component({
  selector:'add',
  templateUrl:'./add.component.html',
  providers: [FollowService, MessageService]
})

export class AddComponent implements OnInit{

      public title:string;
      public message:Message;
      public identity;
      public token;
      public url;
      public status:string ;
      public follows;

      constructor(private _route:ActivatedRoute,private _router:Router,
        private _followService:FollowService,private _messageService:MessageService,private _userService:UserService){

        this.title = 'Enviar missatge';
        this.identity = this._userService.getIdentity();
        this.token = this._userService.gettoken();
        this.url = Global.url;
        this.message = new Message('','','','',this.identity._id,'');



      }
      ngOnInit(){
        console.log('add.component carregat');
        this.getMyFollows();
      }
      onSubmit(form){

          this._messageService.addMessage(this.token,this.message ).subscribe(
          response => {
                        if(!response){

                                 this.status = 'error';
                        }else{
                                this.status = 'success';
                                console.log(response);
                                form.reset();
                        }

                  },
                  error =>{
                    var errorMessage = <any>error;
                    this._router.navigate(['/profile',this.identity._id]);
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
      }

      getMyFollows(){
        this._followService.getMyFollows(this.token).subscribe(
          response => {


                        if(!response){

                                 this.status = 'error';
                        }else{
                                this.follows = response.follows;

                        }

                  },
                  error =>{
                    var errorMessage = <any>error;
                    this._router.navigate(['/profile',this.identity._id]);
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
      }

}
