 import {Component, OnInit, DoCheck} from '@angular/core';
//importem tot l necessari
import {Router, ActivatedRoute, Params} from '@angular/router';
import {Follow} from '../../../models/follow';
import {Message} from '../../../models/message';
import {MessageService} from '../../../services/message.service';
import {FollowService} from '../../../services/follow.service';
import {UserService} from '../../../services/user.service';
import {Global} from '../../../services/global';


//definim el component
//adjuntam metadades
@Component({
  selector:'sended',
  templateUrl:'./sended.component.html',
  providers: [FollowService, MessageService]
})

export class SendedComponent implements OnInit{

      public title:string;
      public message:Message;
      public identity;
      public token;
      public url;
      public status:string ;
      public follows;
      public messages: Message [];
      public pages;
      public page;
      public total;
      public next_page;
      public prev_page;



      constructor(private _route:ActivatedRoute,private _router:Router,
        private _followService:FollowService,private _messageService:MessageService,private _userService:UserService){

        this.title = 'Missatges enviats';
        this.identity = this._userService.getIdentity();
        this.token = this._userService.gettoken();
        this.url = Global.url;

      }
      ngOnInit(){
        console.log('sended.component carregat');
        this.actualPage();

      }

      getMessages(token, page){
        this._messageService.getEmmitMessages(token, page).subscribe(
          response => {
                        if(!response){

                                 this.status = 'error';
                        }else{
                                this.status = 'success';
                                this.messages = response.messages;
                                console.log(response);
                                this.total = response.total;
                                this.pages = response.pages;
                                if(page > this.pages){
                                  this._router.navigate(['/missatges',1]);
                                }
                        }



                  },
                  error =>{
                    var errorMessage = <any>error;
                    this._router.navigate(['/profile',this.identity._id]);
                    console.log(errorMessage);
                        if(errorMessage != null){
                          this.status = 'error';
                        }
                  }
              );
      }

        //recollim la pagina actual
        actualPage(){
          this._route.params.subscribe(params =>{
            let page = +params['page'];
            this.page = page;
            if(!page){
              page = 1;
            }else{
              this.next_page = page + 1;
              this.prev_page = page - 1;

              if(this.prev_page <= 0){
                this.prev_page = 1;
              }

            }
            //retornem el llistat d'usuaris
            this.getMessages(this.token, page);

          });

        }


}
