import { NgModule } from '@angular/core';
import { Routes,RouterModule } from '@angular/router';

//carrega de components

import { MainComponent } from './components/main/main.component';
import { AddComponent } from './components/add/add.component';
import { ReceivedComponent } from './components/received/received.component';
import { SendedComponent } from './components/sended/sended.component';
import {UserGuard} from '../services/user.guard';




const messagesRoutes: Routes = [
  //indicam el path de l'objecte
  { path: 'missatges',
    component:MainComponent,
    children: [
        {path: '', redirectTo: 'rebuts', pathMatch: 'full'},//feim la redireccio completa
        {path: 'enviar', component: AddComponent,canActivate:[UserGuard]},
        {path: 'rebuts', component: ReceivedComponent,canActivate:[UserGuard]},
         {path:'rebuts/:page', component: ReceivedComponent,canActivate:[UserGuard]},
        {path: 'enviats', component: SendedComponent,canActivate:[UserGuard]},
        {path: 'enviats/:page', component: SendedComponent,canActivate:[UserGuard]},

    ]},

];

@NgModule({
  imports: [RouterModule.forChild(messagesRoutes)],
  exports: [RouterModule]
})

//exportem la configuració de rutes
export  class MessagesRoutingModule{}

