//definim els serveis i els injectem a una altre classe
import {Injectable} from '@angular/core';
//importem httpClient per a poder fer peticions ajax i HttpHeaders per a poder enviar capçaleres
import {HttpClient, HttpHeaders} from '@angular/common/http';
//importem l'observable per a poder recollir les respostes de l'api
import {Observable} from 'rxjs/observable';
//importem el model d'usuari
import {Follow} from '../models/follow';
//importam la connexió a l'api
import {Global} from './global';


//definim el decorador injectable per a poder ser utilitzat desde qualsevol classe del client
@Injectable()
export class FollowService{
      public url:string;
      constructor(private _http:HttpClient){
            this.url = Global.url;

      }

      addFollow(token, follow): Observable<any>{
          let params = JSON.stringify(follow);//convertim els parametres a objecte
          let headers = new HttpHeaders().set('Content-Type', 'application/json').set('Authorization', token);//decodificam el token
          return this._http.post(this.url + 'follow', params,{headers:headers});

      }

      deleteFollow(token, id):Observable<any>{
          let headers = new HttpHeaders().set('Content-Type', 'application/json').set('Authorization', token);//decodificam el token
          return this._http.delete(this.url + 'follow/'+id,{headers:headers});


      }


      getFollowing(token,user_id=null,page =1):Observable<any>{
          let headers = new HttpHeaders().set('Content-Type', 'application/json').set('Authorization', token);//decodificam el token
          var url = this.url + 'following';
          if(user_id != null){
              url = this.url + 'following/'+user_id+'/'+page;
          }
          return this._http.get(url,{headers:headers});


      }

      getMyFollows(token):Observable<any>{
          let headers = new HttpHeaders().set('Content-Type', 'application/json').set('Authorization', token);//decodificam el token

          return this._http.get(this.url + 'get-my-follows/true' ,{headers:headers});


      }

}
