//definim els serveis i els injectem a una altre classe
import {Injectable} from '@angular/core';
//importem httpClient per a poder fer peticions ajax i HttpHeaders per a poder enviar capçaleres
import {HttpClient, HttpHeaders} from '@angular/common/http';
//importem l'observable per a poder recollir les respostes de l'api
import {Observable} from 'rxjs/observable';
//importem el model d'usuari
import {Publication} from '../models/publication';
//importam la connexió a l'api
import {Global} from './global';


//definim el decorador injectable per a poder ser utilitzat desde qualsevol classe del client
@Injectable()
export class PublicationService{
       public url:string;
      constructor(private _http:HttpClient){
            this.url = Global.url;

      }



   addPublication(token, publication): Observable<any>{

    let params = JSON.stringify(publication);
    let headers = new HttpHeaders().set('Content-Type','application/json')
                        .set('Authorization', token);

    return this._http.post(this.url + 'publication', params, {headers:headers});
   }


   getPublications(token, page = 1): Observable<any>{

    let headers = new HttpHeaders().set('Content-Type','application/json')
                        .set('Authorization', token);

    return this._http.get(this.url + 'publications/' + page , {headers:headers});
   }

    getPublicationsUser(token,user_id, page = 1): Observable<any>{

    let headers = new HttpHeaders().set('Content-Type','application/json')
                        .set('Authorization', token);

    return this._http.get(this.url + 'publications-user/'+ user_id+'/' + page , {headers:headers});
   }

    deletePublication(token, id): Observable<any>{

    let headers = new HttpHeaders().set('Content-Type','application/json')
                        .set('Authorization', token);

    return this._http.delete(this.url + 'publication/' + id , {headers:headers});
   }

}
